<?php
if (!defined('FORUM') ) 
	die();

if ($section == 'pan_fast_entry')
{
	if (isset($_POST['update_config']))
	{
		$form = array_map('trim', $_POST['form']);
	
		foreach ($form as $key => $input)
		{
			// Only update option values that have changed
			if (array_key_exists('o_'.$key, $forum_config) && $forum_config['o_'.$key] != $input)
			{
				if ($input != '' || is_int($input))
					$value = '\''.$forum_db->escape($input).'\'';
				else
					$value = 'NULL';

				$query = array(
					'UPDATE'	=> 'config',
					'SET'		=> 'conf_value='.$value,
					'WHERE'		=> 'conf_name=\'o_'.$forum_db->escape($key).'\''
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				
				// Regenerate the config cache
				if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
					require FORUM_ROOT.'include/cache.php';

				generate_config_cache();

				// If changed sef - remove quick-jump cache
				if (!empty($forum_config['o_sef']) && !empty($form['sef']))
				{
					if ($forum_config['o_sef'] != $form['sef'])
					{
						clean_quickjump_cache();
					}
				}
			}
		}
		
		$message = 'Настройки обновлены';
		$forum_flash->add_info($message);
		
		if($_SERVER['HTTP_REFERER']) {
			$pan_url_from = $_SERVER['HTTP_REFERER']; 
		}
		
		redirect($pan_url_from, $message);
	}
	
	$forum_page['crumbs'] = array(
		array($forum_config['o_board_title'], forum_link($forum_url['index'])),
		array($lang_admin_common['Forum administration'], forum_link($forum_url['admin_index'])),
		array($lang_admin_common['Settings'], forum_link($forum_url['admin_settings_setup'])),
		'Social Auth Settings'
	);

	$forum_page['group_count'] = $forum_page['item_count'] = $forum_page['fld_count'] = 0;

	define('FORUM_PAGE_SECTION', 'settings');
	define('FORUM_PAGE', 'admin-pan-fast-entry');
	require FORUM_ROOT.'header.php';

	// START SUBST - <!-- forum_main -->
	ob_start();

?>

	<div class="main-subhead">
		<h2 class="hn"><span>Настройки Social Autorize</span></h2>
	</div>
	
	<div class="main-content main-frm">
	
		<form class="frm-form" method="post" accept-charset="utf-8" action="<?php echo forum_link($forum_url['pan_fast_entry']) ?>">
			<div class="hidden">
				<input type="hidden" name="csrf_token" value="<?php echo generate_form_token(forum_link($forum_url['pan_fast_entry'])) ?>" />
			</div>


			<div class="content-head">
				<h2 class="hn"><span>Настройки авторизации с помощью соцсетей</span></h2>
			</div>
			<fieldset class="frm-group group<?php echo ++$forum_page['group_count'] ?>">
				<div class="sf-set set<?php echo ++$forum_page['item_count'] ?>">
					<div class="sf-box checkbox">
						<input type="hidden" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_fast_entry_translit]" value="0"/>
						<span class="fld-input"><input type="checkbox" id="fld<?php echo ++$forum_page['fld_count'] ?>" name="form[pan_fast_entry_translit]" value="1"<?php if ($forum_config['o_pan_fast_entry_translit'] == '1') echo ' checked="checked"' ?> /></span>
						<label for="fld<?php echo $forum_page['fld_count'] ?>">Транслит имени</label>
					</div>
				</div>
			</fieldset>

			<div class="content-head">
				<h2 class="hn"><span>вКонтакте</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_vk_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_vk_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_vk_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_vk_secret_key']) ?>" /></span>
				</div>
			</div>

			<div class="content-head">
				<h2 class="hn"><span>Одноклассники</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_ok_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_ok_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_ok_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_ok_secret_key']) ?>" /></span>
				</div>
			</div>
			
			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Public Key</span><small>Публичный ключ</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_ok_public_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_ok_public_key']) ?>" /></span>
				</div>
			</div>
			
			<div class="content-head">
				<h2 class="hn"><span>Mail.Ru</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_mail_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_mail_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_mail_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_mail_secret_key']) ?>" /></span>
				</div>
			</div>

			<div class="content-head">
				<h2 class="hn"><span>Yandex</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_ya_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_ya_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_ya_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_ya_secret_key']) ?>" /></span>
				</div>
			</div>

			<div class="content-head">
				<h2 class="hn"><span>Google</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_google_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_google_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_google_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_google_secret_key']) ?>" /></span>
				</div>
			</div>

			<div class="content-head">
				<h2 class="hn"><span>Facebook</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_fb_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_fb_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_fb_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_fb_secret_key']) ?>" /></span>
				</div>
			</div>

			<div class="content-head">
				<h2 class="hn"><span>Twitter</span></h2>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>ID</span><small>Insert vidget ID</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_tw_widget_id]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_tw_widget_id']) ?>" /></span>
				</div>
			</div>

			<div class="sf-set set">
				<div class="sf-box text">
					<label for="fld"><span>Sicret Key</span><small>Секретный ключ виджета</small></label><br />
					<span class="fld-input"><input type="text" id="fld " name="form[pan_fast_entry_tw_secret_key]" size="55" maxlength="255" value="<?php echo forum_htmlencode($forum_config['o_pan_fast_entry_tw_secret_key']) ?>" /></span>
				</div>
			</div>



			<div class="frm-buttons">
				<span class="submit primary"><input type="submit" name="update_config" value="Обновить" /></span>
			</div>

		</form>

		<div id="info-censored-intro" class="ct-box">
			<p>Хотите больше настроек? Оставьте свое пожелание на нашем форуме <a href="http://panbb.ru/forum/" target="_blank">PanBB.ru</a></p>
		</div>
		
	</div>
<?php

	$tpl_temp = forum_trim(ob_get_contents());
	$tpl_main = str_replace('<!-- forum_main -->', $tpl_temp, $tpl_main);
	ob_end_clean();
	// END SUBST - <!-- forum_main -->

	require FORUM_ROOT.'footer.php';
}

