<?php
if (!defined('FORUM') ) 
	die();

if ( ($forum_user['is_guest']) && (isset($_GET['provider']) && array_key_exists($_GET['provider'], $social_configs) ) )
{
	$soc_provider = $_GET['provider'];
	require_once $ext_info['path'].'/providers/'.$soc_provider.'.php';

	if (!empty($user_mediator['provider']) && !empty($user_mediator['uid']) && $res_uid === true) 
	{
		$query = array(
			'SELECT'	=> 'u.id, u.username, u.email, u.realname, u.url, u.location, u.signature, u.avatar, u.soc_provider, u.soc_uid',
			'FROM'		=> 'users AS u',
			'WHERE'		=> 'u.soc_provider=\''.$forum_db->escape($user_mediator['provider']).'\' AND u.soc_uid=\''.$forum_db->escape($user_mediator['uid']).'\'',
			'LIMIT'		=> 1,
		);
		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		$fetch_user_info = $forum_db->fetch_assoc($result);
		
		//Если уже есть соц пользователь, то авторизовать
		if($forum_db->num_rows($result) > 0)
		{
			$form_username = $fetch_user_info['username'];
			$password1 = $user_mediator['provider'].$user_mediator['uid'].$client_secret['client_secret'];
			$form_password = $password1;
			$save_pass = '1';
			
			//Обновить данные
			if( ($fetch_user_info['realname'] != $user_mediator['realname']) || ($fetch_user_info['avatar'] != $user_mediator['avatar']) )
			{
				$query = array(
					'UPDATE'	=> 'users',
					'SET'		=> 'realname=\''.$forum_db->escape($user_mediator['realname']).'\'',
					'WHERE'		=> 'id='.$fetch_user_info['id']
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
			}
		
		//Если пользователя нет - регистрируем
		} else {
			
			//Проверить, нет ли емаил в базе
			$user_email = !empty($user_mediator['email']) ? $user_mediator['email'] : '1' ;
			$query = array(
				'SELECT'	=> 'u.id',
				'FROM'		=> 'users AS u',
				'WHERE'		=> 'u.username=\''.$forum_db->escape($user_mediator['username']).'\' OR u.email=\''.$forum_db->escape($user_email).'\'',
			);
			$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);

			//Если пользователь есть
			if ($forum_db->num_rows($result) > 0) 
			{
				$errors[] = sprintf('Пользователь с таким E-mail или Логином уже зарегистрирован. Для входа используйте соответствующий провайдер социальной сети или логин выбранный при регистрации.');
			} else {

				//Определить данные для регистрации/авторизации
				$initial_group_id = ($forum_config['o_regs_verify'] == '0') ? $forum_config['o_default_user_group'] : FORUM_UNVERIFIED;

				$password1 = $user_mediator['provider'].$user_mediator['uid'].$client_secret['client_secret'];
				$password = $password1;	//generate functions
				$salt = random_key(12);
				$password_hash = sha1($salt.sha1($password));

				// Timezone & DST
				$timezone = date('Z') / 3600;
				$dst = date('I');
		
				if ($forum_config['o_default_timezone'] == $timezone || $forum_config['o_default_timezone'] == ($timezone - 1))
				{
					$timezone = ($dst) ? $timezone - 1 : $timezone;
				} else {
					$dst = $forum_config['o_default_dst'];
					$timezone = $forum_config['o_default_timezone'];
				}
				
				if ($forum_config['o_pan_fast_entry_translit'] == '1')
					$new_username = sef_friendly($user_mediator['username']);
				else
					$new_username = forum_trim($user_mediator['username']);

				// We do this now to get the last inserted id for later use.
				$user_info = array(
					'username'				=> $new_username,
					'group_id'				=> $initial_group_id,
					'salt'					=> $salt,
					'password'				=> $password,
					'password_hash'			=> $password_hash,
					'email'					=> !is_null($user_mediator['email']) ? forum_trim($user_mediator['email']) : '',
					'realname'				=> !is_null($user_mediator['realname']) ? forum_trim($user_mediator['realname']) : '',
					'email_setting'			=> $forum_config['o_default_email_setting'],
					'timezone'				=> $timezone,
					'dst'					=> $dst,
					'language'				=> $forum_config['o_default_lang'],
					'style'					=> $forum_config['o_default_style'],
					'registered'			=> time(),
					'registration_ip'		=> get_remote_address(),
					'activate_key'			=> ($forum_config['o_regs_verify'] == '1') ? '\''.random_key(8, TRUE).'\'' : 'NULL',
					'require_verification'	=> ($forum_config['o_regs_verify'] == '1'),
					'notify_admins'			=> ($forum_config['o_regs_report'] == '1'),
					'social_provider'		=> $user_mediator['provider'],
					'social_uid'			=> $user_mediator['uid'],
					'url'					=> !empty($user_mediator['url']) ? $user_mediator['url'] : '',
					'location'				=> !empty($user_mediator['location']) ? $user_mediator['location'] : '',
					'signature'				=> !empty($user_mediator['signature']) ? $user_mediator['signature'] : '',
				);

				// Add the user
				$query = array(
					'INSERT'	=> 'username, group_id, password, email, realname, url, location, signature, email_setting, timezone, dst, language, style, registered, registration_ip, last_visit, salt, soc_provider, soc_uid',
					'INTO'		=> 'users',
					'VALUES'	=> '\''.$forum_db->escape($user_info['username']).'\', '.$user_info['group_id'].', \''.$forum_db->escape($user_info['password_hash']).'\', \''.$forum_db->escape($user_info['email']).'\', \''.$forum_db->escape($user_info['realname']).'\', \''.$forum_db->escape($user_info['url']).'\', \''.$forum_db->escape($user_info['location']).'\', \''.$forum_db->escape($user_info['signature']).'\', '.$user_info['email_setting'].', '.floatval($user_info['timezone']).', '.$user_info['dst'].', \''.$forum_db->escape($user_info['language']).'\', \''.$forum_db->escape($user_info['style']).'\', '.$user_info['registered'].', \''.$forum_db->escape($user_info['registration_ip']).'\', '.$user_info['registered'].', \''.$forum_db->escape($user_info['salt']).'\', \''.$forum_db->escape($user_info['social_provider']).'\', '.$user_info['social_uid'].''
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				$new_uid = $forum_db->insert_id();

				if (!empty($user_mediator['avatar']) && $new_uid)
				{
					$avatar_info = getimagesize($user_mediator['avatar']);

					// Determine type
					$extension = null;
					$avatar_type = FORUM_AVATAR_NONE;
					if ($avatar_info[2] == 1)
					{
						$extension = '.gif';
						$avatar_type = FORUM_AVATAR_GIF;
					}
					else if ($avatar_info[2] == 2)
					{
						$extension = '.jpg';
						$avatar_type = FORUM_AVATAR_JPG;
					}
					else if ($avatar_info[2] == 3)
					{
						$extension = '.png';
						$avatar_type = FORUM_AVATAR_PNG;
					}
					
					copy($user_mediator['avatar'], $forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
					
					if (file_exists($forum_config['o_avatars_dir'].'/'.$new_uid.$extension) && $extension != null)
					{
						if ($forum_config['o_avatars'] == '1')
						{
							$br_im_size = getimagesize($forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
							if ($br_im_size != 0) {
								if ($br_im_size[0]>$br_im_size[1]) {
									$br_cof = $forum_config['o_avatars_width']/$br_im_size[0];
								} else {
									$br_cof = $forum_config['o_avatars_height']/$br_im_size[1];
								}
							}

							if ($avatar_type == FORUM_AVATAR_JPG)
							{
								$img1 = imagecreatefromjpeg($forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
								$img2 = imagecreatetruecolor($br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof);
								imagefill($img2, 0, 0, 0xFFFFFF);
								imagecopyresampled($img2, $img1, 0, 0, 0, 0, $br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof, imagesx($img1), imagesy($img1));
								imagejpeg($img2, $forum_config['o_avatars_dir'].'/'.$new_uid.$extension, 100);
								imagedestroy($img1);
								imagedestroy($img2);
							} else if ($avatar_type == FORUM_AVATAR_PNG) {
								$img1 = imagecreatefrompng($forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
								$img2 = imagecreatetruecolor($br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof);
								imagefill($img2, 0, 0, 0xFFFFFF);
								imagecopyresampled($img2, $img1, 0, 0, 0, 0, $br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof, imagesx($img1), imagesy($img1));
								imagesavealpha($img2, true);
								$trans_colour = imagecolorallocatealpha($img2, 0, 0, 0, 127);
								imagefill($img2, 0, 0, $trans_colour);
								imagepng($img2, $forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
								imagedestroy($img1);
								imagedestroy($img2);
	
							} else if ($avatar_type == FORUM_AVATAR_GIF) {
								$img1 = imagecreatefromgif($forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
								$img2 = imagecreatetruecolor($br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof);
								imagefill($img2, 0, 0, 0xFFFFFF);
								imagecopyresampled($img2, $img1, 0, 0, 0, 0, $br_im_size[0]*$br_cof, $br_im_size[1]*$br_cof, imagesx($img1), imagesy($img1));
								imagesavealpha($img2, true);
								$trans_colour = imagecolorallocatealpha($img2, 0, 0, 0, 127);
								imagefill($img2, 0, 0, $trans_colour);
								imagegif($img2, $forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
								imagedestroy($img1);
								imagedestroy($img2);
							}
							
							$o_avatar_size = getimagesize($forum_config['o_avatars_dir'].'/'.$new_uid.$extension);
							$forum_config['o_avatars_width'] = $o_avatar_size[0];
							$forum_config['o_avatars_height'] = $o_avatar_size[1];
							
							
							// Put the new avatar in its place
							@chmod($forum_config['o_avatars_dir'].'/'.$new_uid.$extension, 0644);
							
							$query = array(
								'UPDATE'	=> 'users',
								'SET'		=> 'avatar=\''.$avatar_info[2].'\', avatar_height=\''.$forum_config['o_avatars_height'].'\', avatar_width=\''.$forum_config['o_avatars_width'].'\'',
								'WHERE'		=> 'id='.$new_uid
							);
							$forum_db->query_build($query) or error(__FILE__, __LINE__);
						}
					}
				}
				
				
				$form_username = $user_mediator['username'];
				$password1 = $user_mediator['provider'].$user_mediator['uid'].$client_secret['client_secret'];
				$form_password = $password1;
				$save_pass = '1';
			}

		}

		// Get user info matching login attempt
		$query = array(
			'SELECT'	=> 'u.id, u.group_id, u.password, u.salt',
			'FROM'		=> 'users AS u'
		);
		if (in_array($db_type, array('mysql', 'mysqli', 'mysql_innodb', 'mysqli_innodb')))
			$query['WHERE'] = 'username=\''.$forum_db->escape($form_username).'\'';
		else
			$query['WHERE'] = 'LOWER(username)=LOWER(\''.$forum_db->escape($form_username).'\')';

		$result = $forum_db->query_build($query) or error(__FILE__, __LINE__);
		list($user_id, $group_id, $db_password_hash, $salt) = $forum_db->fetch_row($result);

		$authorized = false;
		if (!empty($db_password_hash))
		{
			$sha1_in_db = (strlen($db_password_hash) == 40) ? true : false;
			$form_password_hash = forum_hash($form_password, $salt);

			if ($sha1_in_db && $db_password_hash == $form_password_hash)
				$authorized = true;
			else if ((!$sha1_in_db && $db_password_hash == md5($form_password)) || ($sha1_in_db && $db_password_hash == sha1($form_password)))
			{
				$authorized = true;
				$salt = random_key(12);
				$form_password_hash = forum_hash($form_password, $salt);
				// There's an old MD5 hash or an unsalted SHA1 hash in the database, so we replace it
				// with a randomly generated salt and a new, salted SHA1 hash
				$query = array(
					'UPDATE'	=> 'users',
					'SET'		=> 'password=\''.$form_password_hash.'\', salt=\''.$forum_db->escape($salt).'\'',
					'WHERE'		=> 'id='.$user_id
				);
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
			}
		}

		if (!$authorized)
			$errors[] = sprintf($lang_login['Wrong user/pass']);

		// Autorization =========================================
		if (empty($errors))
		{
			// Update the status if this is the first time the user logged in
			if ($group_id == FORUM_UNVERIFIED)
			{
				$query = array(
					'UPDATE'	=> 'users',
					'SET'		=> 'group_id='.$forum_config['o_default_user_group'],
					'WHERE'		=> 'id='.$user_id
				);
				//($hook = get_hook('li_login_qr_update_user_group')) ? eval($hook) : null;
				$forum_db->query_build($query) or error(__FILE__, __LINE__);
				// Remove cache file with forum stats
				if (!defined('FORUM_CACHE_FUNCTIONS_LOADED'))
				{
					require FORUM_ROOT.'include/cache.php';
				}
				clean_stats_cache();
			}
			// Remove this user's guest entry from the online list
			$query = array(
				'DELETE'	=> 'online',
				'WHERE'		=> 'ident=\''.$forum_db->escape(get_remote_address()).'\''
			);
			$forum_db->query_build($query) or error(__FILE__, __LINE__);

			$expire = ($save_pass) ? time() + 1209600 : time() + $forum_config['o_timeout_visit'];
			forum_setcookie($cookie_name, base64_encode($user_id.'|'.$form_password_hash.'|'.$expire.'|'.sha1($salt.$form_password_hash.forum_hash($expire, $salt))), $expire);

			redirect(forum_link($forum_url['index']), $lang_login['Login redirect']);
		}
	
	} else { 
		message('Невозможно авторизоваться. Не определен provider или uid');
	}

}

