<?php

if (!defined('FORUM') ) 
	die();
/**		@author Russeler.Com
 * 		@modified PanBB.Ru
 * 		@package pan_fast_entry
 * 		@licensed As_it_is
*/
if (!empty($forum_config['o_pan_fast_entry_tw_widget_id']) && !empty($forum_config['o_pan_fast_entry_tw_secret_key']))
{
	define('CONSUMER_KEY', $forum_config['o_pan_fast_entry_tw_widget_id']);
	define('CONSUMER_SECRET', $forum_config['o_pan_fast_entry_tw_secret_key']);

	// адрес получения токена запроса
	define('REQUEST_TOKEN_URL', 'https://api.twitter.com/oauth/request_token');
	// адрес аутентификации
	define('AUTHORIZE_URL', 'https://api.twitter.com/oauth/authorize');
	// адрес получения токена доступа
	define('ACCESS_TOKEN_URL', 'https://api.twitter.com/oauth/access_token');
	// адрес API получения информации о пользователе
	define('ACCOUNT_DATA_URL', 'https://api.twitter.com/1.1/users/show.json');
	//define('ACCOUNT_DATA_URL', 'https://api.twitter.com/oauth2/token');

	// колбэк, адрес куда должен будет перенаправлен пользователь, после аутентификации
	define('CALLBACK_URL', (forum_link($forum_url['login']).'?provider=twitter') );

	//определим разделитель, который отделять параметры друг от друга
	define('URL_SEPARATOR', '&');

	// хэш случайной строки
	$oauth_nonce = md5(uniqid(rand(), true));

	// текущее время
	$oauth_timestamp = time();

	// формируем набор параметров
	$params = array(
		'oauth_callback=' . urlencode(CALLBACK_URL) . URL_SEPARATOR,
		'oauth_consumer_key=' . CONSUMER_KEY . URL_SEPARATOR,
		'oauth_nonce=' . $oauth_nonce . URL_SEPARATOR,
		'oauth_signature_method=HMAC-SHA1' . URL_SEPARATOR,
		'oauth_timestamp=' . $oauth_timestamp . URL_SEPARATOR,
		'oauth_version=1.0'
	);

	// склеиваем все параметры, применяя к каждому из них функцию urlencode
	$oauth_base_text = implode('', array_map('urlencode', $params));

	// специальный ключ
	$key = CONSUMER_SECRET . URL_SEPARATOR;

	// формируем общий текст строки
	$oauth_base_text = 'GET' . URL_SEPARATOR . urlencode(REQUEST_TOKEN_URL) . URL_SEPARATOR . $oauth_base_text;

	// хэшируем с помощью алгоритма sha1
	$oauth_signature = base64_encode(hash_hmac('sha1', $oauth_base_text, $key, true));

	// готовим массив параметров
	$params = array(
		URL_SEPARATOR . 'oauth_consumer_key=' . CONSUMER_KEY,
		'oauth_nonce=' . $oauth_nonce,
		'oauth_signature=' . urlencode($oauth_signature),
		'oauth_signature_method=HMAC-SHA1',
		'oauth_timestamp=' . $oauth_timestamp,
		'oauth_version=1.0'
	);

	// склеиваем параметры для формирования url
	$twitter_url = REQUEST_TOKEN_URL . '?oauth_callback=' . urlencode(CALLBACK_URL) . implode('&', $params);

	// Отправляем GET запрос по сформированному url
	//повесил собаку, травит ошибка: failed to open stream: HTTP request failed!
	$response = @file_get_contents($twitter_url);

	// Парсим ответ
	parse_str($response, $response);

	// записываем ответ в переменные
	$oauth_token = $response['oauth_token'];
	$oauth_token_secret = $response['oauth_token_secret'];

	$twitter_link = AUTHORIZE_URL . '?oauth_token=' . $oauth_token;
}


$client_url = array(
	'google' => array(
		'client_url'	=> 'https://accounts.google.com/o/oauth2/auth',
		'title'			=> 'Войти с помощью учетной записи Google+',
		'alt'			=> 'социальная кнопка Google+ фото',
	),
	'facebook' => array(
		'client_url'	=> 'https://www.facebook.com/dialog/oauth',
		'title'			=> 'Войти с помощью Facebook',
		'alt'			=> 'социальная кнопка Facebook фото',
	),
	'twitter' => array(
		'client_url'	=> isset($twitter_link) ? $twitter_link : '',
		'title'			=> 'Войти с помощью Twitter',
		'alt'			=> 'социальная кнопка Twitter фото',
	),
	'yandex' => array(
		'client_url'	=> 'https://oauth.yandex.ru/authorize',
		'title'			=> 'Войти с помощью Яндекс',
		'alt'			=> 'социальная кнопка Яндекс Yandex фото',
	),
	'vk' => array(
		'client_url'	=> 'http://oauth.vk.com/authorize',
		'title'			=> 'Войти с помощью вКонтакте',
		'alt'			=> 'социальная кнопка вКонтакте vk фото',
	),
	'mailru' => array(
		'client_url'	=> 'https://connect.mail.ru/oauth/authorize',
		'title'			=> 'Войти с помощью Mail.Ru',
		'alt'			=> 'социальная кнопка Mail.Ru фото',
	),
	'odnoklassniki' => array(
		'client_url'	=> 'http://www.odnoklassniki.ru/oauth/authorize',
		'title'			=> 'Войти с помощью социальной сети Одноклассники',
		'alt'			=> 'социальная кнопка Одноклассники фото',
	),
);

$social_configs = array(
	'google' => array(
		'redirect_uri'  => forum_link($forum_url['login']).'?provider=google',
		'response_type' => 'code',
		'client_id'     => $forum_config['o_pan_fast_entry_google_widget_id'],
		'scope'         => 'https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile'
	),
	'facebook' => array(
		'client_id'     => $forum_config['o_pan_fast_entry_fb_widget_id'],
		'redirect_uri'  => forum_link($forum_url['login']).'?provider=facebook',
		'response_type' => 'code',
		'scope'         => 'email,user_birthday'
	),
	'twitter' => array(
		'client_id'     => $forum_config['o_pan_fast_entry_tw_widget_id'],
		'response_type' => 'code',
		'redirect_uri'  => forum_link($forum_url['login']).'?provider=twitter'
	),
	'yandex' => array(
		'response_type' => 'code',
		'client_id'     => $forum_config['o_pan_fast_entry_ya_widget_id'],
//		'redirect_uri'  => forum_link($forum_url['login']).'??provider=yandex',
		'display'       => 'popup'
	),
	'vk' => array(
		'client_id'		=> $forum_config['o_pan_fast_entry_vk_widget_id'],
		'redirect_uri'	=> forum_link($forum_url['login']).'?provider=vk',
		'response_type' => 'code'
	),
	'mailru' => array(
		'client_id'     => $forum_config['o_pan_fast_entry_mail_widget_id'],
		'response_type' => 'code',
		'redirect_uri'  => forum_link($forum_url['login']).'?provider=mailru'
	),
	'odnoklassniki' => array(
		'client_id'     => $forum_config['o_pan_fast_entry_ok_widget_id'],
		'response_type' => 'code',
		'redirect_uri'  => forum_link($forum_url['login']).'?provider=odnoklassniki'
	),
);

